# Ideas

There are functions for mutating tracks, and functions for cloning tracks (but not yet for restoring).

Once you have sufficient functions, there needs to be some way to manage this from a control source.
Ideally something robust so you ca easily twiddle and play and experiment.



** Note **

You can re-open Renoise classes to add new methods and stuff (for a cleaner API)

    http://forum.renoise.com/index.php/topic/32821-lua-renoisesongtracksmemberstrack-index/



# TODO


** Function to swap lines **

Given a pattern track, you indicate a mod number (every `mod_num` lines) and that line and the line n lines away are swapped.

Need to account for PT wrapping  (so some modulo math).

Possible approach:

- clone the PT as we've done before
- calculate what lines are to be swapped by creating some sort of list of pairs
- use that list to copy lines fomr the clone PT to the original.



** DONE Function to do some sort of line shifting **
  Pass a track index, a line mod number, and a shift number (e.g. 2 3 1)
  Assume pattern-track level for now
  For each line in the track, if it matches the line mod, then shift the line contents by the given number of lines
  BUT: Need a plan to avoid endlessly shifting lines as you iterate. Might need a buffer, or work opposite of the shift direction.
  Need to account for pattern wrapping

    Possible plan: Copy pattern track to some temp spot.  Use roate tool to shift the whole thing.
    Then, iterate over results and copy over the mod lines into the target pattern (and just overwrite whatever is there).

  The tool is effectively a "striped" rotate.


Possible approach -

Given that we have a copy of the original PT ad have done the rotation by n lines:

  The goal is to shift (rotate) every mod lines by n lines.
  We have a PT copy rotate (all lines) by n
  From this we want to grab only lines that would have been changed by the mod|n process.
      mod=3 n=2

  1     7                                   1
  2     8                                   2
  3     1           *        Now what?      3
  4     2                                   4
  5     3                                   5
  6     4           *                       6
  7     5                                   7
  8     6                                   8


  Line 3 has changed, but because it now contains line 1.  We can set line 3 to 1, but what happens to line 1?
  Do we consider it moved?

        _ (clear)
        2
        1
        _ (clear)
        5
        4
        7
        8

Can we do this just with *math* and then just move the lines in-place?

## Mon 10 Sep 2018 19:30:54

Put another way, if we are rotating every 2nd line by threee: we first clear (in the original) every 2nd line (since they are getting rotated) and then copy over from the copy those lines *3 places* from their original source


      1 A         -> f
      2 b  ***   
      3 c         -> h 
      4 d  ***
      5 e         -> b
      6 f  ***
      7 g         -> d
      8 h  ***


- Create an empty PT
- copy over every mod line
- rotate the copy PT by n
- Go back to the original and clear every mod line
- Go to copy and copy back to the orginal ... what? 

You can't just copy non-empty lines, since empty lines may have been among the rotated.

In the example, we have an 8-line pattern, moved every 2nd line my 3 lines.
We know then we are copying back every n line.  But at what lone do we start?

For each mod line, add the rotation and do sum%num-pattern-lines.

2+3 % 8 = 5     
4+3 % 8 = 7     
6+3 % 8 = 1     
8+3 % 8 = 3

Lowest value is where we start.    



** Testing in a real song **


transformation expect after /ng/rotate/pattern/striped 1  2 3

Rotate PT in track 1, by 2 lines, effecting every 3rd line

      00  C4    C6        X         C6        
      01  D4    D6                  D4       
      02  E4    C4    *   _         _     
      03  F4    D4        X         D4     
      04  G4    E4                  G4   
      05  A4    F4    *   _         _     
      06  B4    G4        X          G4    
      07  C5    A4                  C5   
      08  D5    B4    *   _         _   
      09  E5    C5        X          C5 
      10  F5    D5                  F5 
      11  G5    E5    *   _         _  
      12  A5    F5         X        F5
      13  B5    G5                 B5
      14  C6    A5    *   _         _
      15  D6    B5        X         B5


It's not working.

Step 1: See that we are correctly deleting lines from the original (source) PT

Issue: The deletions are starting at the first line. If we want every 2nd line we want 2,4,6,..

but we get 1,3,5,..

Fixed: Now have the ierator for deletion start at `mod_num` (and not 1!)

And the other error was not an error.  The hand-computed resutls were wrong.

Seems to work now.





# Using a controller 

The 266 has a 4x4 grid, and 4 sets of rotatries and sliders.

Some ideas:

** Assume you can only operate on 4 tracks **

Then each rotary is fixed to a track, each slider the same, and each column is a function for a specific track.

For example: clone, restore, something, something.  

Downside: Lack of easy options for more operations.  

Maybe those last two buttons alter how the sliders+rotaries work.

E.g. button 3 woud toggle the slider to so striping.  (Nice to have: a way to roll back the strip as you move the sider in the opposite direction.  Or, think of each iteration as acting on the original data. But this requires some way to keep track of the original data before this alteration. Hmmm ...)

Or, button 3 or 4 *activates* the commands using the current slider. You set the slider, hit a button, that does the action.

Rotaries would just do rotation, as you turn them.

Or, just get used to doing clone, mutate 1; restore, clone , mutate 2, ...

You can also use a second controller.

